
/* autogenerated from convert_orc.orc */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifndef _ORC_INTEGER_TYPEDEFS_
#define _ORC_INTEGER_TYPEDEFS_
#if defined(__STDC_VERSION__) && __STDC_VERSION__ >= 199901L
#include <stdint.h>
typedef int8_t orc_int8;
typedef int16_t orc_int16;
typedef int32_t orc_int32;
typedef int64_t orc_int64;
typedef uint8_t orc_uint8;
typedef uint16_t orc_uint16;
typedef uint32_t orc_uint32;
typedef uint64_t orc_uint64;
#define ORC_UINT64_C(x) UINT64_C(x)
#elif defined(_MSC_VER)
typedef signed __int8 orc_int8;
typedef signed __int16 orc_int16;
typedef signed __int32 orc_int32;
typedef signed __int64 orc_int64;
typedef unsigned __int8 orc_uint8;
typedef unsigned __int16 orc_uint16;
typedef unsigned __int32 orc_uint32;
typedef unsigned __int64 orc_uint64;
#define ORC_UINT64_C(x) (x##Ui64)
#define inline __inline
#else
#include <limits.h>
typedef signed char orc_int8;
typedef short orc_int16;
typedef int orc_int32;
typedef unsigned char orc_uint8;
typedef unsigned short orc_uint16;
typedef unsigned int orc_uint32;
#if INT_MAX == LONG_MAX
typedef long long orc_int64;
typedef unsigned long long orc_uint64;
#define ORC_UINT64_C(x) (x##ULL)
#else
typedef long orc_int64;
typedef unsigned long orc_uint64;
#define ORC_UINT64_C(x) (x##UL)
#endif
#endif
typedef union { orc_int16 i; orc_int8 x2[2]; } orc_union16;
typedef union { orc_int32 i; float f; orc_int16 x2[2]; orc_int8 x4[4]; } orc_union32;
typedef union { orc_int64 i; double f; orc_int32 x2[2]; float x2f[2]; orc_int16 x4[4]; } orc_union64;
#endif
#ifndef ORC_RESTRICT
#if defined(__STDC_VERSION__) && __STDC_VERSION__ >= 199901L
#define ORC_RESTRICT restrict
#elif defined(__GNUC__) && __GNUC__ >= 4
#define ORC_RESTRICT __restrict__
#else
#define ORC_RESTRICT
#endif
#endif

#ifndef ORC_INTERNAL
#if defined(__SUNPRO_C) && (__SUNPRO_C >= 0x590)
#define ORC_INTERNAL __attribute__((visibility("hidden")))
#elif defined(__SUNPRO_C) && (__SUNPRO_C >= 0x550)
#define ORC_INTERNAL __hidden
#elif defined (__GNUC__)
#define ORC_INTERNAL __attribute__((visibility("hidden")))
#else
#define ORC_INTERNAL
#endif
#endif


#ifndef DISABLE_ORC
#include <orc/orc.h>
#endif
void _convert_fc32_1_to_item32_1_nswap_orc (orc_uint32 * ORC_RESTRICT d1, const orc_uint64 * ORC_RESTRICT s1, float p1, int n);
void _convert_fc32_1_to_item32_1_bswap_orc (orc_uint32 * ORC_RESTRICT d1, const orc_uint64 * ORC_RESTRICT s1, float p1, int n);
void _convert_item32_1_to_fc32_1_nswap_orc (orc_uint64 * ORC_RESTRICT d1, const orc_uint32 * ORC_RESTRICT s1, float p1, int n);
void _convert_item32_1_to_fc32_1_bswap_orc (orc_uint64 * ORC_RESTRICT d1, const orc_uint32 * ORC_RESTRICT s1, float p1, int n);
void _convert_sc16_1_to_item32_1_nswap_orc (orc_uint32 * ORC_RESTRICT d1, const orc_uint32 * ORC_RESTRICT s1, float p1, int n);
void _convert_item32_1_to_sc16_1_nswap_orc (orc_uint32 * ORC_RESTRICT d1, const orc_uint32 * ORC_RESTRICT s1, float p1, int n);
void _convert_swap_byte_pairs_orc (orc_uint32 * ORC_RESTRICT d1, const orc_uint32 * ORC_RESTRICT s1, int n);
void _convert_fc32_1_to_sc8_1_nswap_orc (orc_uint16 * ORC_RESTRICT d1, const orc_uint64 * ORC_RESTRICT s1, float p1, int n);


/* begin Orc C target preamble */
#define ORC_CLAMP(x,a,b) ((x)<(a) ? (a) : ((x)>(b) ? (b) : (x)))
#define ORC_ABS(a) ((a)<0 ? -(a) : (a))
#define ORC_MIN(a,b) ((a)<(b) ? (a) : (b))
#define ORC_MAX(a,b) ((a)>(b) ? (a) : (b))
#define ORC_SB_MAX 127
#define ORC_SB_MIN (-1-ORC_SB_MAX)
#define ORC_UB_MAX 255
#define ORC_UB_MIN 0
#define ORC_SW_MAX 32767
#define ORC_SW_MIN (-1-ORC_SW_MAX)
#define ORC_UW_MAX 65535
#define ORC_UW_MIN 0
#define ORC_SL_MAX 2147483647
#define ORC_SL_MIN (-1-ORC_SL_MAX)
#define ORC_UL_MAX 4294967295U
#define ORC_UL_MIN 0
#define ORC_CLAMP_SB(x) ORC_CLAMP(x,ORC_SB_MIN,ORC_SB_MAX)
#define ORC_CLAMP_UB(x) ORC_CLAMP(x,ORC_UB_MIN,ORC_UB_MAX)
#define ORC_CLAMP_SW(x) ORC_CLAMP(x,ORC_SW_MIN,ORC_SW_MAX)
#define ORC_CLAMP_UW(x) ORC_CLAMP(x,ORC_UW_MIN,ORC_UW_MAX)
#define ORC_CLAMP_SL(x) ORC_CLAMP(x,ORC_SL_MIN,ORC_SL_MAX)
#define ORC_CLAMP_UL(x) ORC_CLAMP(x,ORC_UL_MIN,ORC_UL_MAX)
#define ORC_SWAP_W(x) ((((x)&0xffU)<<8) | (((x)&0xff00U)>>8))
#define ORC_SWAP_L(x) ((((x)&0xffU)<<24) | (((x)&0xff00U)<<8) | (((x)&0xff0000U)>>8) | (((x)&0xff000000U)>>24))
#define ORC_SWAP_Q(x) ((((x)&ORC_UINT64_C(0xff))<<56) | (((x)&ORC_UINT64_C(0xff00))<<40) | (((x)&ORC_UINT64_C(0xff0000))<<24) | (((x)&ORC_UINT64_C(0xff000000))<<8) | (((x)&ORC_UINT64_C(0xff00000000))>>8) | (((x)&ORC_UINT64_C(0xff0000000000))>>24) | (((x)&ORC_UINT64_C(0xff000000000000))>>40) | (((x)&ORC_UINT64_C(0xff00000000000000))>>56))
#define ORC_PTR_OFFSET(ptr,offset) ((void *)(((unsigned char *)(ptr)) + (offset)))
#define ORC_DENORMAL(x) ((x) & ((((x)&0x7f800000) == 0) ? 0xff800000 : 0xffffffff))
#define ORC_ISNAN(x) ((((x)&0x7f800000) == 0x7f800000) && (((x)&0x007fffff) != 0))
#define ORC_DENORMAL_DOUBLE(x) ((x) & ((((x)&ORC_UINT64_C(0x7ff0000000000000)) == 0) ? ORC_UINT64_C(0xfff0000000000000) : ORC_UINT64_C(0xffffffffffffffff)))
#define ORC_ISNAN_DOUBLE(x) ((((x)&ORC_UINT64_C(0x7ff0000000000000)) == ORC_UINT64_C(0x7ff0000000000000)) && (((x)&ORC_UINT64_C(0x000fffffffffffff)) != 0))
#ifndef ORC_RESTRICT
#if defined(__STDC_VERSION__) && __STDC_VERSION__ >= 199901L
#define ORC_RESTRICT restrict
#elif defined(__GNUC__) && __GNUC__ >= 4
#define ORC_RESTRICT __restrict__
#else
#define ORC_RESTRICT
#endif
#endif
/* end Orc C target preamble */



/* _convert_fc32_1_to_item32_1_nswap_orc */
#ifdef DISABLE_ORC
void
_convert_fc32_1_to_item32_1_nswap_orc (orc_uint32 * ORC_RESTRICT d1, const orc_uint64 * ORC_RESTRICT s1, float p1, int n){
  int i;
  orc_union32 * ORC_RESTRICT ptr0;
  const orc_union64 * ORC_RESTRICT ptr4;
  orc_union64 var35;
  orc_union64 var36;
  orc_union32 var37;
  orc_union64 var38;
  orc_union64 var39;
  orc_union32 var40;
  orc_union32 var41;

  ptr0 = (orc_union32 *)d1;
  ptr4 = (orc_union64 *)s1;

    /* 1: loadpl */
    var36.x2f[0] = p1;
    var36.x2f[1] = p1;

  for (i = 0; i < n; i++) {
    /* 0: loadq */
    var35 = ptr4[i];
    /* 2: mulf */
    {
       orc_union32 _src1;
       orc_union32 _src2;
       orc_union32 _dest1;
       _src1.i = ORC_DENORMAL(var35.x2[0]);
       _src2.i = ORC_DENORMAL(var36.x2[0]);
       _dest1.f = _src1.f * _src2.f;
       var38.x2[0] = ORC_DENORMAL(_dest1.i);
    }
    {
       orc_union32 _src1;
       orc_union32 _src2;
       orc_union32 _dest1;
       _src1.i = ORC_DENORMAL(var35.x2[1]);
       _src2.i = ORC_DENORMAL(var36.x2[1]);
       _dest1.f = _src1.f * _src2.f;
       var38.x2[1] = ORC_DENORMAL(_dest1.i);
    }
    /* 3: convfl */
    {
       int tmp;
       tmp = (int)var38.x2f[0];
       if (tmp == 0x80000000 && !(var38.x2[0]&0x80000000)) tmp = 0x7fffffff;
       var39.x2[0] = tmp;
    }
    {
       int tmp;
       tmp = (int)var38.x2f[1];
       if (tmp == 0x80000000 && !(var38.x2[1]&0x80000000)) tmp = 0x7fffffff;
       var39.x2[1] = tmp;
    }
    /* 4: convlw */
    var40.x2[0] = var39.x2[0];
    var40.x2[1] = var39.x2[1];
    /* 5: swapl */
    var41.i = ORC_SWAP_L(var40.i);
    /* 6: swapw */
    var37.x2[0] = ORC_SWAP_W(var41.x2[0]);
    var37.x2[1] = ORC_SWAP_W(var41.x2[1]);
    /* 7: storel */
    ptr0[i] = var37;
  }

}

#else
static void
_backup__convert_fc32_1_to_item32_1_nswap_orc (OrcExecutor * ORC_RESTRICT ex)
{
  int i;
  int n = ex->n;
  orc_union32 * ORC_RESTRICT ptr0;
  const orc_union64 * ORC_RESTRICT ptr4;
  orc_union64 var35;
  orc_union64 var36;
  orc_union32 var37;
  orc_union64 var38;
  orc_union64 var39;
  orc_union32 var40;
  orc_union32 var41;

  ptr0 = (orc_union32 *)ex->arrays[0];
  ptr4 = (orc_union64 *)ex->arrays[4];

    /* 1: loadpl */
    var36.x2[0] = ex->params[24];
    var36.x2[1] = ex->params[24];

  for (i = 0; i < n; i++) {
    /* 0: loadq */
    var35 = ptr4[i];
    /* 2: mulf */
    {
       orc_union32 _src1;
       orc_union32 _src2;
       orc_union32 _dest1;
       _src1.i = ORC_DENORMAL(var35.x2[0]);
       _src2.i = ORC_DENORMAL(var36.x2[0]);
       _dest1.f = _src1.f * _src2.f;
       var38.x2[0] = ORC_DENORMAL(_dest1.i);
    }
    {
       orc_union32 _src1;
       orc_union32 _src2;
       orc_union32 _dest1;
       _src1.i = ORC_DENORMAL(var35.x2[1]);
       _src2.i = ORC_DENORMAL(var36.x2[1]);
       _dest1.f = _src1.f * _src2.f;
       var38.x2[1] = ORC_DENORMAL(_dest1.i);
    }
    /* 3: convfl */
    {
       int tmp;
       tmp = (int)var38.x2f[0];
       if (tmp == 0x80000000 && !(var38.x2[0]&0x80000000)) tmp = 0x7fffffff;
       var39.x2[0] = tmp;
    }
    {
       int tmp;
       tmp = (int)var38.x2f[1];
       if (tmp == 0x80000000 && !(var38.x2[1]&0x80000000)) tmp = 0x7fffffff;
       var39.x2[1] = tmp;
    }
    /* 4: convlw */
    var40.x2[0] = var39.x2[0];
    var40.x2[1] = var39.x2[1];
    /* 5: swapl */
    var41.i = ORC_SWAP_L(var40.i);
    /* 6: swapw */
    var37.x2[0] = ORC_SWAP_W(var41.x2[0]);
    var37.x2[1] = ORC_SWAP_W(var41.x2[1]);
    /* 7: storel */
    ptr0[i] = var37;
  }

}

void
_convert_fc32_1_to_item32_1_nswap_orc (orc_uint32 * ORC_RESTRICT d1, const orc_uint64 * ORC_RESTRICT s1, float p1, int n)
{
  OrcExecutor _ex, *ex = &_ex;
  static volatile int p_inited = 0;
  static OrcCode *c = 0;
  void (*func) (OrcExecutor *);

  if (!p_inited) {
    orc_once_mutex_lock ();
    if (!p_inited) {
      OrcProgram *p;

#if 1
      static const orc_uint8 bc[] = {
        1, 9, 37, 95, 99, 111, 110, 118, 101, 114, 116, 95, 102, 99, 51, 50, 
        95, 49, 95, 116, 111, 95, 105, 116, 101, 109, 51, 50, 95, 49, 95, 110, 
        115, 119, 97, 112, 95, 111, 114, 99, 11, 4, 4, 12, 8, 8, 17, 4, 
        20, 8, 20, 8, 20, 4, 21, 1, 202, 32, 4, 24, 21, 1, 210, 33, 
        32, 21, 1, 163, 34, 33, 184, 34, 34, 21, 1, 183, 0, 34, 2, 0, 

      };
      p = orc_program_new_from_static_bytecode (bc);
      orc_program_set_backup_function (p, _backup__convert_fc32_1_to_item32_1_nswap_orc);
#else
      p = orc_program_new ();
      orc_program_set_name (p, "_convert_fc32_1_to_item32_1_nswap_orc");
      orc_program_set_backup_function (p, _backup__convert_fc32_1_to_item32_1_nswap_orc);
      orc_program_add_destination (p, 4, "d1");
      orc_program_add_source (p, 8, "s1");
      orc_program_add_parameter_float (p, 4, "p1");
      orc_program_add_temporary (p, 8, "t1");
      orc_program_add_temporary (p, 8, "t2");
      orc_program_add_temporary (p, 4, "t3");

      orc_program_append_2 (p, "mulf", 1, ORC_VAR_T1, ORC_VAR_S1, ORC_VAR_P1, ORC_VAR_D1);
      orc_program_append_2 (p, "convfl", 1, ORC_VAR_T2, ORC_VAR_T1, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "convlw", 1, ORC_VAR_T3, ORC_VAR_T2, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "swapl", 0, ORC_VAR_T3, ORC_VAR_T3, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "swapw", 1, ORC_VAR_D1, ORC_VAR_T3, ORC_VAR_D1, ORC_VAR_D1);
#endif

      orc_program_compile (p);
      c = orc_program_take_code (p);
      orc_program_free (p);
    }
    p_inited = TRUE;
    orc_once_mutex_unlock ();
  }
  ex->arrays[ORC_VAR_A2] = c;
  ex->program = 0;

  ex->n = n;
  ex->arrays[ORC_VAR_D1] = d1;
  ex->arrays[ORC_VAR_S1] = (void *)s1;
  {
    orc_union32 tmp;
    tmp.f = p1;
    ex->params[ORC_VAR_P1] = tmp.i;
  }

  func = c->exec;
  func (ex);
}
#endif


/* _convert_fc32_1_to_item32_1_bswap_orc */
#ifdef DISABLE_ORC
void
_convert_fc32_1_to_item32_1_bswap_orc (orc_uint32 * ORC_RESTRICT d1, const orc_uint64 * ORC_RESTRICT s1, float p1, int n){
  int i;
  orc_union32 * ORC_RESTRICT ptr0;
  const orc_union64 * ORC_RESTRICT ptr4;
  orc_union64 var35;
  orc_union64 var36;
  orc_union32 var37;
  orc_union64 var38;
  orc_union64 var39;
  orc_union32 var40;

  ptr0 = (orc_union32 *)d1;
  ptr4 = (orc_union64 *)s1;

    /* 1: loadpl */
    var36.x2f[0] = p1;
    var36.x2f[1] = p1;

  for (i = 0; i < n; i++) {
    /* 0: loadq */
    var35 = ptr4[i];
    /* 2: mulf */
    {
       orc_union32 _src1;
       orc_union32 _src2;
       orc_union32 _dest1;
       _src1.i = ORC_DENORMAL(var35.x2[0]);
       _src2.i = ORC_DENORMAL(var36.x2[0]);
       _dest1.f = _src1.f * _src2.f;
       var38.x2[0] = ORC_DENORMAL(_dest1.i);
    }
    {
       orc_union32 _src1;
       orc_union32 _src2;
       orc_union32 _dest1;
       _src1.i = ORC_DENORMAL(var35.x2[1]);
       _src2.i = ORC_DENORMAL(var36.x2[1]);
       _dest1.f = _src1.f * _src2.f;
       var38.x2[1] = ORC_DENORMAL(_dest1.i);
    }
    /* 3: convfl */
    {
       int tmp;
       tmp = (int)var38.x2f[0];
       if (tmp == 0x80000000 && !(var38.x2[0]&0x80000000)) tmp = 0x7fffffff;
       var39.x2[0] = tmp;
    }
    {
       int tmp;
       tmp = (int)var38.x2f[1];
       if (tmp == 0x80000000 && !(var38.x2[1]&0x80000000)) tmp = 0x7fffffff;
       var39.x2[1] = tmp;
    }
    /* 4: convlw */
    var40.x2[0] = var39.x2[0];
    var40.x2[1] = var39.x2[1];
    /* 5: swapw */
    var37.x2[0] = ORC_SWAP_W(var40.x2[0]);
    var37.x2[1] = ORC_SWAP_W(var40.x2[1]);
    /* 6: storel */
    ptr0[i] = var37;
  }

}

#else
static void
_backup__convert_fc32_1_to_item32_1_bswap_orc (OrcExecutor * ORC_RESTRICT ex)
{
  int i;
  int n = ex->n;
  orc_union32 * ORC_RESTRICT ptr0;
  const orc_union64 * ORC_RESTRICT ptr4;
  orc_union64 var35;
  orc_union64 var36;
  orc_union32 var37;
  orc_union64 var38;
  orc_union64 var39;
  orc_union32 var40;

  ptr0 = (orc_union32 *)ex->arrays[0];
  ptr4 = (orc_union64 *)ex->arrays[4];

    /* 1: loadpl */
    var36.x2[0] = ex->params[24];
    var36.x2[1] = ex->params[24];

  for (i = 0; i < n; i++) {
    /* 0: loadq */
    var35 = ptr4[i];
    /* 2: mulf */
    {
       orc_union32 _src1;
       orc_union32 _src2;
       orc_union32 _dest1;
       _src1.i = ORC_DENORMAL(var35.x2[0]);
       _src2.i = ORC_DENORMAL(var36.x2[0]);
       _dest1.f = _src1.f * _src2.f;
       var38.x2[0] = ORC_DENORMAL(_dest1.i);
    }
    {
       orc_union32 _src1;
       orc_union32 _src2;
       orc_union32 _dest1;
       _src1.i = ORC_DENORMAL(var35.x2[1]);
       _src2.i = ORC_DENORMAL(var36.x2[1]);
       _dest1.f = _src1.f * _src2.f;
       var38.x2[1] = ORC_DENORMAL(_dest1.i);
    }
    /* 3: convfl */
    {
       int tmp;
       tmp = (int)var38.x2f[0];
       if (tmp == 0x80000000 && !(var38.x2[0]&0x80000000)) tmp = 0x7fffffff;
       var39.x2[0] = tmp;
    }
    {
       int tmp;
       tmp = (int)var38.x2f[1];
       if (tmp == 0x80000000 && !(var38.x2[1]&0x80000000)) tmp = 0x7fffffff;
       var39.x2[1] = tmp;
    }
    /* 4: convlw */
    var40.x2[0] = var39.x2[0];
    var40.x2[1] = var39.x2[1];
    /* 5: swapw */
    var37.x2[0] = ORC_SWAP_W(var40.x2[0]);
    var37.x2[1] = ORC_SWAP_W(var40.x2[1]);
    /* 6: storel */
    ptr0[i] = var37;
  }

}

void
_convert_fc32_1_to_item32_1_bswap_orc (orc_uint32 * ORC_RESTRICT d1, const orc_uint64 * ORC_RESTRICT s1, float p1, int n)
{
  OrcExecutor _ex, *ex = &_ex;
  static volatile int p_inited = 0;
  static OrcCode *c = 0;
  void (*func) (OrcExecutor *);

  if (!p_inited) {
    orc_once_mutex_lock ();
    if (!p_inited) {
      OrcProgram *p;

#if 1
      static const orc_uint8 bc[] = {
        1, 9, 37, 95, 99, 111, 110, 118, 101, 114, 116, 95, 102, 99, 51, 50, 
        95, 49, 95, 116, 111, 95, 105, 116, 101, 109, 51, 50, 95, 49, 95, 98, 
        115, 119, 97, 112, 95, 111, 114, 99, 11, 4, 4, 12, 8, 8, 17, 4, 
        20, 8, 20, 8, 20, 4, 21, 1, 202, 32, 4, 24, 21, 1, 210, 33, 
        32, 21, 1, 163, 34, 33, 21, 1, 183, 0, 34, 2, 0, 
      };
      p = orc_program_new_from_static_bytecode (bc);
      orc_program_set_backup_function (p, _backup__convert_fc32_1_to_item32_1_bswap_orc);
#else
      p = orc_program_new ();
      orc_program_set_name (p, "_convert_fc32_1_to_item32_1_bswap_orc");
      orc_program_set_backup_function (p, _backup__convert_fc32_1_to_item32_1_bswap_orc);
      orc_program_add_destination (p, 4, "d1");
      orc_program_add_source (p, 8, "s1");
      orc_program_add_parameter_float (p, 4, "p1");
      orc_program_add_temporary (p, 8, "t1");
      orc_program_add_temporary (p, 8, "t2");
      orc_program_add_temporary (p, 4, "t3");

      orc_program_append_2 (p, "mulf", 1, ORC_VAR_T1, ORC_VAR_S1, ORC_VAR_P1, ORC_VAR_D1);
      orc_program_append_2 (p, "convfl", 1, ORC_VAR_T2, ORC_VAR_T1, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "convlw", 1, ORC_VAR_T3, ORC_VAR_T2, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "swapw", 1, ORC_VAR_D1, ORC_VAR_T3, ORC_VAR_D1, ORC_VAR_D1);
#endif

      orc_program_compile (p);
      c = orc_program_take_code (p);
      orc_program_free (p);
    }
    p_inited = TRUE;
    orc_once_mutex_unlock ();
  }
  ex->arrays[ORC_VAR_A2] = c;
  ex->program = 0;

  ex->n = n;
  ex->arrays[ORC_VAR_D1] = d1;
  ex->arrays[ORC_VAR_S1] = (void *)s1;
  {
    orc_union32 tmp;
    tmp.f = p1;
    ex->params[ORC_VAR_P1] = tmp.i;
  }

  func = c->exec;
  func (ex);
}
#endif


/* _convert_item32_1_to_fc32_1_nswap_orc */
#ifdef DISABLE_ORC
void
_convert_item32_1_to_fc32_1_nswap_orc (orc_uint64 * ORC_RESTRICT d1, const orc_uint32 * ORC_RESTRICT s1, float p1, int n){
  int i;
  orc_union64 * ORC_RESTRICT ptr0;
  const orc_union32 * ORC_RESTRICT ptr4;
  orc_union32 var34;
  orc_union64 var35;
  orc_union64 var36;
  orc_union32 var37;
  orc_union32 var38;
  orc_union64 var39;
  orc_union64 var40;

  ptr0 = (orc_union64 *)d1;
  ptr4 = (orc_union32 *)s1;

    /* 5: loadpl */
    var35.x2f[0] = p1;
    var35.x2f[1] = p1;

  for (i = 0; i < n; i++) {
    /* 0: loadl */
    var34 = ptr4[i];
    /* 1: swapw */
    var37.x2[0] = ORC_SWAP_W(var34.x2[0]);
    var37.x2[1] = ORC_SWAP_W(var34.x2[1]);
    /* 2: swapl */
    var38.i = ORC_SWAP_L(var37.i);
    /* 3: convswl */
    var39.x2[0] = var38.x2[0];
    var39.x2[1] = var38.x2[1];
    /* 4: convlf */
    var40.x2f[0] = var39.x2[0];
    var40.x2f[1] = var39.x2[1];
    /* 6: mulf */
    {
       orc_union32 _src1;
       orc_union32 _src2;
       orc_union32 _dest1;
       _src1.i = ORC_DENORMAL(var40.x2[0]);
       _src2.i = ORC_DENORMAL(var35.x2[0]);
       _dest1.f = _src1.f * _src2.f;
       var36.x2[0] = ORC_DENORMAL(_dest1.i);
    }
    {
       orc_union32 _src1;
       orc_union32 _src2;
       orc_union32 _dest1;
       _src1.i = ORC_DENORMAL(var40.x2[1]);
       _src2.i = ORC_DENORMAL(var35.x2[1]);
       _dest1.f = _src1.f * _src2.f;
       var36.x2[1] = ORC_DENORMAL(_dest1.i);
    }
    /* 7: storeq */
    ptr0[i] = var36;
  }

}

#else
static void
_backup__convert_item32_1_to_fc32_1_nswap_orc (OrcExecutor * ORC_RESTRICT ex)
{
  int i;
  int n = ex->n;
  orc_union64 * ORC_RESTRICT ptr0;
  const orc_union32 * ORC_RESTRICT ptr4;
  orc_union32 var34;
  orc_union64 var35;
  orc_union64 var36;
  orc_union32 var37;
  orc_union32 var38;
  orc_union64 var39;
  orc_union64 var40;

  ptr0 = (orc_union64 *)ex->arrays[0];
  ptr4 = (orc_union32 *)ex->arrays[4];

    /* 5: loadpl */
    var35.x2[0] = ex->params[24];
    var35.x2[1] = ex->params[24];

  for (i = 0; i < n; i++) {
    /* 0: loadl */
    var34 = ptr4[i];
    /* 1: swapw */
    var37.x2[0] = ORC_SWAP_W(var34.x2[0]);
    var37.x2[1] = ORC_SWAP_W(var34.x2[1]);
    /* 2: swapl */
    var38.i = ORC_SWAP_L(var37.i);
    /* 3: convswl */
    var39.x2[0] = var38.x2[0];
    var39.x2[1] = var38.x2[1];
    /* 4: convlf */
    var40.x2f[0] = var39.x2[0];
    var40.x2f[1] = var39.x2[1];
    /* 6: mulf */
    {
       orc_union32 _src1;
       orc_union32 _src2;
       orc_union32 _dest1;
       _src1.i = ORC_DENORMAL(var40.x2[0]);
       _src2.i = ORC_DENORMAL(var35.x2[0]);
       _dest1.f = _src1.f * _src2.f;
       var36.x2[0] = ORC_DENORMAL(_dest1.i);
    }
    {
       orc_union32 _src1;
       orc_union32 _src2;
       orc_union32 _dest1;
       _src1.i = ORC_DENORMAL(var40.x2[1]);
       _src2.i = ORC_DENORMAL(var35.x2[1]);
       _dest1.f = _src1.f * _src2.f;
       var36.x2[1] = ORC_DENORMAL(_dest1.i);
    }
    /* 7: storeq */
    ptr0[i] = var36;
  }

}

void
_convert_item32_1_to_fc32_1_nswap_orc (orc_uint64 * ORC_RESTRICT d1, const orc_uint32 * ORC_RESTRICT s1, float p1, int n)
{
  OrcExecutor _ex, *ex = &_ex;
  static volatile int p_inited = 0;
  static OrcCode *c = 0;
  void (*func) (OrcExecutor *);

  if (!p_inited) {
    orc_once_mutex_lock ();
    if (!p_inited) {
      OrcProgram *p;

#if 1
      static const orc_uint8 bc[] = {
        1, 9, 37, 95, 99, 111, 110, 118, 101, 114, 116, 95, 105, 116, 101, 109, 
        51, 50, 95, 49, 95, 116, 111, 95, 102, 99, 51, 50, 95, 49, 95, 110, 
        115, 119, 97, 112, 95, 111, 114, 99, 11, 8, 8, 12, 4, 4, 17, 4, 
        20, 4, 20, 8, 21, 1, 183, 32, 4, 184, 32, 32, 21, 1, 153, 33, 
        32, 21, 1, 211, 33, 33, 21, 1, 202, 0, 33, 24, 2, 0, 
      };
      p = orc_program_new_from_static_bytecode (bc);
      orc_program_set_backup_function (p, _backup__convert_item32_1_to_fc32_1_nswap_orc);
#else
      p = orc_program_new ();
      orc_program_set_name (p, "_convert_item32_1_to_fc32_1_nswap_orc");
      orc_program_set_backup_function (p, _backup__convert_item32_1_to_fc32_1_nswap_orc);
      orc_program_add_destination (p, 8, "d1");
      orc_program_add_source (p, 4, "s1");
      orc_program_add_parameter_float (p, 4, "p1");
      orc_program_add_temporary (p, 4, "t1");
      orc_program_add_temporary (p, 8, "t2");

      orc_program_append_2 (p, "swapw", 1, ORC_VAR_T1, ORC_VAR_S1, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "swapl", 0, ORC_VAR_T1, ORC_VAR_T1, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "convswl", 1, ORC_VAR_T2, ORC_VAR_T1, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "convlf", 1, ORC_VAR_T2, ORC_VAR_T2, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "mulf", 1, ORC_VAR_D1, ORC_VAR_T2, ORC_VAR_P1, ORC_VAR_D1);
#endif

      orc_program_compile (p);
      c = orc_program_take_code (p);
      orc_program_free (p);
    }
    p_inited = TRUE;
    orc_once_mutex_unlock ();
  }
  ex->arrays[ORC_VAR_A2] = c;
  ex->program = 0;

  ex->n = n;
  ex->arrays[ORC_VAR_D1] = d1;
  ex->arrays[ORC_VAR_S1] = (void *)s1;
  {
    orc_union32 tmp;
    tmp.f = p1;
    ex->params[ORC_VAR_P1] = tmp.i;
  }

  func = c->exec;
  func (ex);
}
#endif


/* _convert_item32_1_to_fc32_1_bswap_orc */
#ifdef DISABLE_ORC
void
_convert_item32_1_to_fc32_1_bswap_orc (orc_uint64 * ORC_RESTRICT d1, const orc_uint32 * ORC_RESTRICT s1, float p1, int n){
  int i;
  orc_union64 * ORC_RESTRICT ptr0;
  const orc_union32 * ORC_RESTRICT ptr4;
  orc_union32 var34;
  orc_union64 var35;
  orc_union64 var36;
  orc_union32 var37;
  orc_union64 var38;
  orc_union64 var39;

  ptr0 = (orc_union64 *)d1;
  ptr4 = (orc_union32 *)s1;

    /* 4: loadpl */
    var35.x2f[0] = p1;
    var35.x2f[1] = p1;

  for (i = 0; i < n; i++) {
    /* 0: loadl */
    var34 = ptr4[i];
    /* 1: swapw */
    var37.x2[0] = ORC_SWAP_W(var34.x2[0]);
    var37.x2[1] = ORC_SWAP_W(var34.x2[1]);
    /* 2: convswl */
    var38.x2[0] = var37.x2[0];
    var38.x2[1] = var37.x2[1];
    /* 3: convlf */
    var39.x2f[0] = var38.x2[0];
    var39.x2f[1] = var38.x2[1];
    /* 5: mulf */
    {
       orc_union32 _src1;
       orc_union32 _src2;
       orc_union32 _dest1;
       _src1.i = ORC_DENORMAL(var39.x2[0]);
       _src2.i = ORC_DENORMAL(var35.x2[0]);
       _dest1.f = _src1.f * _src2.f;
       var36.x2[0] = ORC_DENORMAL(_dest1.i);
    }
    {
       orc_union32 _src1;
       orc_union32 _src2;
       orc_union32 _dest1;
       _src1.i = ORC_DENORMAL(var39.x2[1]);
       _src2.i = ORC_DENORMAL(var35.x2[1]);
       _dest1.f = _src1.f * _src2.f;
       var36.x2[1] = ORC_DENORMAL(_dest1.i);
    }
    /* 6: storeq */
    ptr0[i] = var36;
  }

}

#else
static void
_backup__convert_item32_1_to_fc32_1_bswap_orc (OrcExecutor * ORC_RESTRICT ex)
{
  int i;
  int n = ex->n;
  orc_union64 * ORC_RESTRICT ptr0;
  const orc_union32 * ORC_RESTRICT ptr4;
  orc_union32 var34;
  orc_union64 var35;
  orc_union64 var36;
  orc_union32 var37;
  orc_union64 var38;
  orc_union64 var39;

  ptr0 = (orc_union64 *)ex->arrays[0];
  ptr4 = (orc_union32 *)ex->arrays[4];

    /* 4: loadpl */
    var35.x2[0] = ex->params[24];
    var35.x2[1] = ex->params[24];

  for (i = 0; i < n; i++) {
    /* 0: loadl */
    var34 = ptr4[i];
    /* 1: swapw */
    var37.x2[0] = ORC_SWAP_W(var34.x2[0]);
    var37.x2[1] = ORC_SWAP_W(var34.x2[1]);
    /* 2: convswl */
    var38.x2[0] = var37.x2[0];
    var38.x2[1] = var37.x2[1];
    /* 3: convlf */
    var39.x2f[0] = var38.x2[0];
    var39.x2f[1] = var38.x2[1];
    /* 5: mulf */
    {
       orc_union32 _src1;
       orc_union32 _src2;
       orc_union32 _dest1;
       _src1.i = ORC_DENORMAL(var39.x2[0]);
       _src2.i = ORC_DENORMAL(var35.x2[0]);
       _dest1.f = _src1.f * _src2.f;
       var36.x2[0] = ORC_DENORMAL(_dest1.i);
    }
    {
       orc_union32 _src1;
       orc_union32 _src2;
       orc_union32 _dest1;
       _src1.i = ORC_DENORMAL(var39.x2[1]);
       _src2.i = ORC_DENORMAL(var35.x2[1]);
       _dest1.f = _src1.f * _src2.f;
       var36.x2[1] = ORC_DENORMAL(_dest1.i);
    }
    /* 6: storeq */
    ptr0[i] = var36;
  }

}

void
_convert_item32_1_to_fc32_1_bswap_orc (orc_uint64 * ORC_RESTRICT d1, const orc_uint32 * ORC_RESTRICT s1, float p1, int n)
{
  OrcExecutor _ex, *ex = &_ex;
  static volatile int p_inited = 0;
  static OrcCode *c = 0;
  void (*func) (OrcExecutor *);

  if (!p_inited) {
    orc_once_mutex_lock ();
    if (!p_inited) {
      OrcProgram *p;

#if 1
      static const orc_uint8 bc[] = {
        1, 9, 37, 95, 99, 111, 110, 118, 101, 114, 116, 95, 105, 116, 101, 109, 
        51, 50, 95, 49, 95, 116, 111, 95, 102, 99, 51, 50, 95, 49, 95, 98, 
        115, 119, 97, 112, 95, 111, 114, 99, 11, 8, 8, 12, 4, 4, 17, 4, 
        20, 4, 20, 8, 21, 1, 183, 32, 4, 21, 1, 153, 33, 32, 21, 1, 
        211, 33, 33, 21, 1, 202, 0, 33, 24, 2, 0, 
      };
      p = orc_program_new_from_static_bytecode (bc);
      orc_program_set_backup_function (p, _backup__convert_item32_1_to_fc32_1_bswap_orc);
#else
      p = orc_program_new ();
      orc_program_set_name (p, "_convert_item32_1_to_fc32_1_bswap_orc");
      orc_program_set_backup_function (p, _backup__convert_item32_1_to_fc32_1_bswap_orc);
      orc_program_add_destination (p, 8, "d1");
      orc_program_add_source (p, 4, "s1");
      orc_program_add_parameter_float (p, 4, "p1");
      orc_program_add_temporary (p, 4, "t1");
      orc_program_add_temporary (p, 8, "t2");

      orc_program_append_2 (p, "swapw", 1, ORC_VAR_T1, ORC_VAR_S1, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "convswl", 1, ORC_VAR_T2, ORC_VAR_T1, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "convlf", 1, ORC_VAR_T2, ORC_VAR_T2, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "mulf", 1, ORC_VAR_D1, ORC_VAR_T2, ORC_VAR_P1, ORC_VAR_D1);
#endif

      orc_program_compile (p);
      c = orc_program_take_code (p);
      orc_program_free (p);
    }
    p_inited = TRUE;
    orc_once_mutex_unlock ();
  }
  ex->arrays[ORC_VAR_A2] = c;
  ex->program = 0;

  ex->n = n;
  ex->arrays[ORC_VAR_D1] = d1;
  ex->arrays[ORC_VAR_S1] = (void *)s1;
  {
    orc_union32 tmp;
    tmp.f = p1;
    ex->params[ORC_VAR_P1] = tmp.i;
  }

  func = c->exec;
  func (ex);
}
#endif


/* _convert_sc16_1_to_item32_1_nswap_orc */
#ifdef DISABLE_ORC
void
_convert_sc16_1_to_item32_1_nswap_orc (orc_uint32 * ORC_RESTRICT d1, const orc_uint32 * ORC_RESTRICT s1, float p1, int n){
  int i;
  orc_union32 * ORC_RESTRICT ptr0;
  const orc_union32 * ORC_RESTRICT ptr4;
  orc_union32 var33;
  orc_union32 var34;
  orc_union32 var35;

  ptr0 = (orc_union32 *)d1;
  ptr4 = (orc_union32 *)s1;


  for (i = 0; i < n; i++) {
    /* 0: loadl */
    var33 = ptr4[i];
    /* 1: swapl */
    var35.i = ORC_SWAP_L(var33.i);
    /* 2: swapw */
    var34.x2[0] = ORC_SWAP_W(var35.x2[0]);
    var34.x2[1] = ORC_SWAP_W(var35.x2[1]);
    /* 3: storel */
    ptr0[i] = var34;
  }

}

#else
static void
_backup__convert_sc16_1_to_item32_1_nswap_orc (OrcExecutor * ORC_RESTRICT ex)
{
  int i;
  int n = ex->n;
  orc_union32 * ORC_RESTRICT ptr0;
  const orc_union32 * ORC_RESTRICT ptr4;
  orc_union32 var33;
  orc_union32 var34;
  orc_union32 var35;

  ptr0 = (orc_union32 *)ex->arrays[0];
  ptr4 = (orc_union32 *)ex->arrays[4];


  for (i = 0; i < n; i++) {
    /* 0: loadl */
    var33 = ptr4[i];
    /* 1: swapl */
    var35.i = ORC_SWAP_L(var33.i);
    /* 2: swapw */
    var34.x2[0] = ORC_SWAP_W(var35.x2[0]);
    var34.x2[1] = ORC_SWAP_W(var35.x2[1]);
    /* 3: storel */
    ptr0[i] = var34;
  }

}

void
_convert_sc16_1_to_item32_1_nswap_orc (orc_uint32 * ORC_RESTRICT d1, const orc_uint32 * ORC_RESTRICT s1, float p1, int n)
{
  OrcExecutor _ex, *ex = &_ex;
  static volatile int p_inited = 0;
  static OrcCode *c = 0;
  void (*func) (OrcExecutor *);

  if (!p_inited) {
    orc_once_mutex_lock ();
    if (!p_inited) {
      OrcProgram *p;

#if 1
      static const orc_uint8 bc[] = {
        1, 9, 37, 95, 99, 111, 110, 118, 101, 114, 116, 95, 115, 99, 49, 54, 
        95, 49, 95, 116, 111, 95, 105, 116, 101, 109, 51, 50, 95, 49, 95, 110, 
        115, 119, 97, 112, 95, 111, 114, 99, 11, 4, 4, 12, 4, 4, 17, 4, 
        20, 4, 184, 32, 4, 21, 1, 183, 0, 32, 2, 0, 
      };
      p = orc_program_new_from_static_bytecode (bc);
      orc_program_set_backup_function (p, _backup__convert_sc16_1_to_item32_1_nswap_orc);
#else
      p = orc_program_new ();
      orc_program_set_name (p, "_convert_sc16_1_to_item32_1_nswap_orc");
      orc_program_set_backup_function (p, _backup__convert_sc16_1_to_item32_1_nswap_orc);
      orc_program_add_destination (p, 4, "d1");
      orc_program_add_source (p, 4, "s1");
      orc_program_add_parameter_float (p, 4, "p1");
      orc_program_add_temporary (p, 4, "t1");

      orc_program_append_2 (p, "swapl", 0, ORC_VAR_T1, ORC_VAR_S1, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "swapw", 1, ORC_VAR_D1, ORC_VAR_T1, ORC_VAR_D1, ORC_VAR_D1);
#endif

      orc_program_compile (p);
      c = orc_program_take_code (p);
      orc_program_free (p);
    }
    p_inited = TRUE;
    orc_once_mutex_unlock ();
  }
  ex->arrays[ORC_VAR_A2] = c;
  ex->program = 0;

  ex->n = n;
  ex->arrays[ORC_VAR_D1] = d1;
  ex->arrays[ORC_VAR_S1] = (void *)s1;
  {
    orc_union32 tmp;
    tmp.f = p1;
    ex->params[ORC_VAR_P1] = tmp.i;
  }

  func = c->exec;
  func (ex);
}
#endif


/* _convert_item32_1_to_sc16_1_nswap_orc */
#ifdef DISABLE_ORC
void
_convert_item32_1_to_sc16_1_nswap_orc (orc_uint32 * ORC_RESTRICT d1, const orc_uint32 * ORC_RESTRICT s1, float p1, int n){
  int i;
  orc_union32 * ORC_RESTRICT ptr0;
  const orc_union32 * ORC_RESTRICT ptr4;
  orc_union32 var33;
  orc_union32 var34;
  orc_union32 var35;

  ptr0 = (orc_union32 *)d1;
  ptr4 = (orc_union32 *)s1;


  for (i = 0; i < n; i++) {
    /* 0: loadl */
    var33 = ptr4[i];
    /* 1: swapw */
    var35.x2[0] = ORC_SWAP_W(var33.x2[0]);
    var35.x2[1] = ORC_SWAP_W(var33.x2[1]);
    /* 2: swapl */
    var34.i = ORC_SWAP_L(var35.i);
    /* 3: storel */
    ptr0[i] = var34;
  }

}

#else
static void
_backup__convert_item32_1_to_sc16_1_nswap_orc (OrcExecutor * ORC_RESTRICT ex)
{
  int i;
  int n = ex->n;
  orc_union32 * ORC_RESTRICT ptr0;
  const orc_union32 * ORC_RESTRICT ptr4;
  orc_union32 var33;
  orc_union32 var34;
  orc_union32 var35;

  ptr0 = (orc_union32 *)ex->arrays[0];
  ptr4 = (orc_union32 *)ex->arrays[4];


  for (i = 0; i < n; i++) {
    /* 0: loadl */
    var33 = ptr4[i];
    /* 1: swapw */
    var35.x2[0] = ORC_SWAP_W(var33.x2[0]);
    var35.x2[1] = ORC_SWAP_W(var33.x2[1]);
    /* 2: swapl */
    var34.i = ORC_SWAP_L(var35.i);
    /* 3: storel */
    ptr0[i] = var34;
  }

}

void
_convert_item32_1_to_sc16_1_nswap_orc (orc_uint32 * ORC_RESTRICT d1, const orc_uint32 * ORC_RESTRICT s1, float p1, int n)
{
  OrcExecutor _ex, *ex = &_ex;
  static volatile int p_inited = 0;
  static OrcCode *c = 0;
  void (*func) (OrcExecutor *);

  if (!p_inited) {
    orc_once_mutex_lock ();
    if (!p_inited) {
      OrcProgram *p;

#if 1
      static const orc_uint8 bc[] = {
        1, 9, 37, 95, 99, 111, 110, 118, 101, 114, 116, 95, 105, 116, 101, 109, 
        51, 50, 95, 49, 95, 116, 111, 95, 115, 99, 49, 54, 95, 49, 95, 110, 
        115, 119, 97, 112, 95, 111, 114, 99, 11, 4, 4, 12, 4, 4, 17, 4, 
        20, 4, 21, 1, 183, 32, 4, 184, 0, 32, 2, 0, 
      };
      p = orc_program_new_from_static_bytecode (bc);
      orc_program_set_backup_function (p, _backup__convert_item32_1_to_sc16_1_nswap_orc);
#else
      p = orc_program_new ();
      orc_program_set_name (p, "_convert_item32_1_to_sc16_1_nswap_orc");
      orc_program_set_backup_function (p, _backup__convert_item32_1_to_sc16_1_nswap_orc);
      orc_program_add_destination (p, 4, "d1");
      orc_program_add_source (p, 4, "s1");
      orc_program_add_parameter_float (p, 4, "p1");
      orc_program_add_temporary (p, 4, "t1");

      orc_program_append_2 (p, "swapw", 1, ORC_VAR_T1, ORC_VAR_S1, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "swapl", 0, ORC_VAR_D1, ORC_VAR_T1, ORC_VAR_D1, ORC_VAR_D1);
#endif

      orc_program_compile (p);
      c = orc_program_take_code (p);
      orc_program_free (p);
    }
    p_inited = TRUE;
    orc_once_mutex_unlock ();
  }
  ex->arrays[ORC_VAR_A2] = c;
  ex->program = 0;

  ex->n = n;
  ex->arrays[ORC_VAR_D1] = d1;
  ex->arrays[ORC_VAR_S1] = (void *)s1;
  {
    orc_union32 tmp;
    tmp.f = p1;
    ex->params[ORC_VAR_P1] = tmp.i;
  }

  func = c->exec;
  func (ex);
}
#endif


/* _convert_swap_byte_pairs_orc */
#ifdef DISABLE_ORC
void
_convert_swap_byte_pairs_orc (orc_uint32 * ORC_RESTRICT d1, const orc_uint32 * ORC_RESTRICT s1, int n){
  int i;
  orc_union32 * ORC_RESTRICT ptr0;
  const orc_union32 * ORC_RESTRICT ptr4;
  orc_union32 var32;
  orc_union32 var33;

  ptr0 = (orc_union32 *)d1;
  ptr4 = (orc_union32 *)s1;


  for (i = 0; i < n; i++) {
    /* 0: loadl */
    var32 = ptr4[i];
    /* 1: swapl */
    var33.i = ORC_SWAP_L(var32.i);
    /* 2: storel */
    ptr0[i] = var33;
  }

}

#else
static void
_backup__convert_swap_byte_pairs_orc (OrcExecutor * ORC_RESTRICT ex)
{
  int i;
  int n = ex->n;
  orc_union32 * ORC_RESTRICT ptr0;
  const orc_union32 * ORC_RESTRICT ptr4;
  orc_union32 var32;
  orc_union32 var33;

  ptr0 = (orc_union32 *)ex->arrays[0];
  ptr4 = (orc_union32 *)ex->arrays[4];


  for (i = 0; i < n; i++) {
    /* 0: loadl */
    var32 = ptr4[i];
    /* 1: swapl */
    var33.i = ORC_SWAP_L(var32.i);
    /* 2: storel */
    ptr0[i] = var33;
  }

}

void
_convert_swap_byte_pairs_orc (orc_uint32 * ORC_RESTRICT d1, const orc_uint32 * ORC_RESTRICT s1, int n)
{
  OrcExecutor _ex, *ex = &_ex;
  static volatile int p_inited = 0;
  static OrcCode *c = 0;
  void (*func) (OrcExecutor *);

  if (!p_inited) {
    orc_once_mutex_lock ();
    if (!p_inited) {
      OrcProgram *p;

#if 1
      static const orc_uint8 bc[] = {
        1, 9, 28, 95, 99, 111, 110, 118, 101, 114, 116, 95, 115, 119, 97, 112, 
        95, 98, 121, 116, 101, 95, 112, 97, 105, 114, 115, 95, 111, 114, 99, 11, 
        4, 4, 12, 4, 4, 184, 0, 4, 2, 0, 
      };
      p = orc_program_new_from_static_bytecode (bc);
      orc_program_set_backup_function (p, _backup__convert_swap_byte_pairs_orc);
#else
      p = orc_program_new ();
      orc_program_set_name (p, "_convert_swap_byte_pairs_orc");
      orc_program_set_backup_function (p, _backup__convert_swap_byte_pairs_orc);
      orc_program_add_destination (p, 4, "d1");
      orc_program_add_source (p, 4, "s1");

      orc_program_append_2 (p, "swapl", 0, ORC_VAR_D1, ORC_VAR_S1, ORC_VAR_D1, ORC_VAR_D1);
#endif

      orc_program_compile (p);
      c = orc_program_take_code (p);
      orc_program_free (p);
    }
    p_inited = TRUE;
    orc_once_mutex_unlock ();
  }
  ex->arrays[ORC_VAR_A2] = c;
  ex->program = 0;

  ex->n = n;
  ex->arrays[ORC_VAR_D1] = d1;
  ex->arrays[ORC_VAR_S1] = (void *)s1;

  func = c->exec;
  func (ex);
}
#endif


/* _convert_fc32_1_to_sc8_1_nswap_orc */
#ifdef DISABLE_ORC
void
_convert_fc32_1_to_sc8_1_nswap_orc (orc_uint16 * ORC_RESTRICT d1, const orc_uint64 * ORC_RESTRICT s1, float p1, int n){
  int i;
  orc_union16 * ORC_RESTRICT ptr0;
  const orc_union64 * ORC_RESTRICT ptr4;
  orc_union64 var34;
  orc_union64 var35;
  orc_union16 var36;
  orc_union64 var37;
  orc_union64 var38;
  orc_union32 var39;

  ptr0 = (orc_union16 *)d1;
  ptr4 = (orc_union64 *)s1;

    /* 1: loadpl */
    var35.x2f[0] = p1;
    var35.x2f[1] = p1;

  for (i = 0; i < n; i++) {
    /* 0: loadq */
    var34 = ptr4[i];
    /* 2: mulf */
    {
       orc_union32 _src1;
       orc_union32 _src2;
       orc_union32 _dest1;
       _src1.i = ORC_DENORMAL(var34.x2[0]);
       _src2.i = ORC_DENORMAL(var35.x2[0]);
       _dest1.f = _src1.f * _src2.f;
       var37.x2[0] = ORC_DENORMAL(_dest1.i);
    }
    {
       orc_union32 _src1;
       orc_union32 _src2;
       orc_union32 _dest1;
       _src1.i = ORC_DENORMAL(var34.x2[1]);
       _src2.i = ORC_DENORMAL(var35.x2[1]);
       _dest1.f = _src1.f * _src2.f;
       var37.x2[1] = ORC_DENORMAL(_dest1.i);
    }
    /* 3: convfl */
    {
       int tmp;
       tmp = (int)var37.x2f[0];
       if (tmp == 0x80000000 && !(var37.x2[0]&0x80000000)) tmp = 0x7fffffff;
       var38.x2[0] = tmp;
    }
    {
       int tmp;
       tmp = (int)var37.x2f[1];
       if (tmp == 0x80000000 && !(var37.x2[1]&0x80000000)) tmp = 0x7fffffff;
       var38.x2[1] = tmp;
    }
    /* 4: convlw */
    var39.x2[0] = var38.x2[0];
    var39.x2[1] = var38.x2[1];
    /* 5: convwb */
    var36.x2[0] = var39.x2[0];
    var36.x2[1] = var39.x2[1];
    /* 6: storew */
    ptr0[i] = var36;
  }

}

#else
static void
_backup__convert_fc32_1_to_sc8_1_nswap_orc (OrcExecutor * ORC_RESTRICT ex)
{
  int i;
  int n = ex->n;
  orc_union16 * ORC_RESTRICT ptr0;
  const orc_union64 * ORC_RESTRICT ptr4;
  orc_union64 var34;
  orc_union64 var35;
  orc_union16 var36;
  orc_union64 var37;
  orc_union64 var38;
  orc_union32 var39;

  ptr0 = (orc_union16 *)ex->arrays[0];
  ptr4 = (orc_union64 *)ex->arrays[4];

    /* 1: loadpl */
    var35.x2[0] = ex->params[24];
    var35.x2[1] = ex->params[24];

  for (i = 0; i < n; i++) {
    /* 0: loadq */
    var34 = ptr4[i];
    /* 2: mulf */
    {
       orc_union32 _src1;
       orc_union32 _src2;
       orc_union32 _dest1;
       _src1.i = ORC_DENORMAL(var34.x2[0]);
       _src2.i = ORC_DENORMAL(var35.x2[0]);
       _dest1.f = _src1.f * _src2.f;
       var37.x2[0] = ORC_DENORMAL(_dest1.i);
    }
    {
       orc_union32 _src1;
       orc_union32 _src2;
       orc_union32 _dest1;
       _src1.i = ORC_DENORMAL(var34.x2[1]);
       _src2.i = ORC_DENORMAL(var35.x2[1]);
       _dest1.f = _src1.f * _src2.f;
       var37.x2[1] = ORC_DENORMAL(_dest1.i);
    }
    /* 3: convfl */
    {
       int tmp;
       tmp = (int)var37.x2f[0];
       if (tmp == 0x80000000 && !(var37.x2[0]&0x80000000)) tmp = 0x7fffffff;
       var38.x2[0] = tmp;
    }
    {
       int tmp;
       tmp = (int)var37.x2f[1];
       if (tmp == 0x80000000 && !(var37.x2[1]&0x80000000)) tmp = 0x7fffffff;
       var38.x2[1] = tmp;
    }
    /* 4: convlw */
    var39.x2[0] = var38.x2[0];
    var39.x2[1] = var38.x2[1];
    /* 5: convwb */
    var36.x2[0] = var39.x2[0];
    var36.x2[1] = var39.x2[1];
    /* 6: storew */
    ptr0[i] = var36;
  }

}

void
_convert_fc32_1_to_sc8_1_nswap_orc (orc_uint16 * ORC_RESTRICT d1, const orc_uint64 * ORC_RESTRICT s1, float p1, int n)
{
  OrcExecutor _ex, *ex = &_ex;
  static volatile int p_inited = 0;
  static OrcCode *c = 0;
  void (*func) (OrcExecutor *);

  if (!p_inited) {
    orc_once_mutex_lock ();
    if (!p_inited) {
      OrcProgram *p;

#if 1
      static const orc_uint8 bc[] = {
        1, 9, 34, 95, 99, 111, 110, 118, 101, 114, 116, 95, 102, 99, 51, 50, 
        95, 49, 95, 116, 111, 95, 115, 99, 56, 95, 49, 95, 110, 115, 119, 97, 
        112, 95, 111, 114, 99, 11, 2, 2, 12, 8, 8, 17, 4, 20, 8, 20, 
        4, 21, 1, 202, 32, 4, 24, 21, 1, 210, 32, 32, 21, 1, 163, 33, 
        32, 21, 1, 157, 0, 33, 2, 0, 
      };
      p = orc_program_new_from_static_bytecode (bc);
      orc_program_set_backup_function (p, _backup__convert_fc32_1_to_sc8_1_nswap_orc);
#else
      p = orc_program_new ();
      orc_program_set_name (p, "_convert_fc32_1_to_sc8_1_nswap_orc");
      orc_program_set_backup_function (p, _backup__convert_fc32_1_to_sc8_1_nswap_orc);
      orc_program_add_destination (p, 2, "d1");
      orc_program_add_source (p, 8, "s1");
      orc_program_add_parameter_float (p, 4, "p1");
      orc_program_add_temporary (p, 8, "t1");
      orc_program_add_temporary (p, 4, "t2");

      orc_program_append_2 (p, "mulf", 1, ORC_VAR_T1, ORC_VAR_S1, ORC_VAR_P1, ORC_VAR_D1);
      orc_program_append_2 (p, "convfl", 1, ORC_VAR_T1, ORC_VAR_T1, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "convlw", 1, ORC_VAR_T2, ORC_VAR_T1, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "convwb", 1, ORC_VAR_D1, ORC_VAR_T2, ORC_VAR_D1, ORC_VAR_D1);
#endif

      orc_program_compile (p);
      c = orc_program_take_code (p);
      orc_program_free (p);
    }
    p_inited = TRUE;
    orc_once_mutex_unlock ();
  }
  ex->arrays[ORC_VAR_A2] = c;
  ex->program = 0;

  ex->n = n;
  ex->arrays[ORC_VAR_D1] = d1;
  ex->arrays[ORC_VAR_S1] = (void *)s1;
  {
    orc_union32 tmp;
    tmp.f = p1;
    ex->params[ORC_VAR_P1] = tmp.i;
  }

  func = c->exec;
  func (ex);
}
#endif


